import usb 

VENDOR_RQ_SET_LED    = '1' 
VENDOR_RQ_GET_LIGHT = '2'

def find_board():
    board = None
    for bus in usb.busses():
        for dev in bus.devices:
            if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                return dev 
    return None

board = find_board()
handle = board.open()

def Text2Key(input):
    x = ''
    i = 0
    c = ord(input)
    c = c - 64
    while(i<5):
        x += "%d" %(c%2)
        c = c / 2
        i+=1
    return x

def Key2Text(input):
    k = 0
    i = 0
    for j in input:
        k += (2**i)*int(j)
        i+=1
    return chr(k + 64)

def fn_Sent():
    print "Data :",
    data = raw_input()
    if len(data) <= 10:
        out = ''
        for i in data:
            out += Text2Key(i)
    else:
        print "Data in too long"
    while len(out) <= 50:
        out += '0'
    return out
    
def fn_Recieve(data):
    out = ''
    print "Waiting Data"
    i = 0
    while(i<50):
        x = data[i] + data[i+1] + data[i+2] + data[i+3] + data[i+4]
        if x != '00000':
            out += Key2Text(x)
        else:
            out += '-'
        i += 5
    return out

def writeLed(data):
    for i in data:
        req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        if i == '1':
            handle.controlMsg(req, 0, None, value=0x0100)
            print 1
        else:
            handle.controlMsg(req, 0, None, value=0x0000)
            print 0
def readLed():
    voltrms = 3.5
    i = 0
    output = ''
    while i < 50:
        req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        y = handle.controlMsg(req, 2, 2)
        volt = (((y[0]*256)+y[1])/1023.0)*5.0
        if(volt > voltrms):
            output += '1'
        else:
            output += '0'
    return output
        
logout = 1
while(logout):
    print "++------------------++"
    print "||    -.*Menu*.-    ||"
    print "++------------------++"
    print "| 1.Sent             |"
    print "| 2.Recieve          |"
    print "|                    |"
    print "| .........          |"
    print "| 0.Exit             |"
    print "+--------------------+"
    print " :",
    x = raw_input()
    if x == '1':
        output = fn_Sent()
        writeLed(output)
        print output
    elif x == '2':
        output = fn_Recieve(output)
        print output
    elif x == '0':
        logout = 0 
